#include <iostream>
#include "backend.h"
#include <string>

#include <unistd.h>
#include <dlfcn.h>

int main(int argc, char * argv[])
{
    char curdir[500];
    getcwd(curdir, 500);

    std::cout << "Current dir: " << curdir << std::endl;

    std::string s(curdir);
    s += "/libgfx_";
    s += argv[1];
    s += ".so";
    
    std::cout << s << std::endl;

    void * ldhandle = dlopen(s.c_str(), RTLD_NOW);
    std::cout << ldhandle << std::endl;
    if (!ldhandle) std::cout << dlerror() << std::endl;

    if (!ldhandle) { dlclose(ldhandle); return 1; }

    image * (*getnewimage)(void) =  (image*(*)()) dlsym(ldhandle, "getnewimage");
    void (*deleteimage)(image *) =  (void(*)(image *)) dlsym(ldhandle, "deleteimage");

    std::cout << "Function: " << getnewimage << std::endl;

    if (!getnewimage) return 1;


    image * myimage = getnewimage();

    std::cout << "Image: " << myimage << std::endl;
    myimage->say_something();

    deleteimage(myimage);

    return 0;
}
